/* RandomInt.cpp defines the non-trivial RandomInt operations.

 * Written by: Joel C. Adams at Calvin College.
 * Written for: C++: An Introduction To Computing.
 * Revised: Spring 1997, for C++: An Introduction To Computing 2e.
 *
 * See RandomInt.h for the class declaration,
 *     RandomInt.doc for class documentation.
 ******************************************************************/

#include "RandomInt.h"

bool RandomInt::generatorInitialized = false;

void RandomInt::Initialize(int low, int high)
{
  myLowerBound = low;
  myUpperBound = high;

  if (!generatorInitialized)       // call srand() first time only
    {
      srand(long(time(0)));        // use clock for seed
      generatorInitialized = true;
    }

  myRandomValue = NextRandomInt();
}


void RandomInt::SeededInitialize(int seedValue, int low, int high)
{
  myLowerBound = low;
  myUpperBound = high;
  srand(seedValue);
  generatorInitialized = true;
  myRandomValue = NextRandomInt();
}


RandomInt RandomInt::Generate(int low, int high)
{
  assert(0 <= low);
  assert(low < high);
  myLowerBound = low;
  myUpperBound = high;
  myRandomValue = NextRandomInt();
  return *this;
}

